-- Tic-Tac-Toe 0.3 is a game written by Karl Noss. Visit www.karlnoss.com

function on.escapeKey()	--resets game, returns to titles
	titles = true
	twoHumans = true
	turn = 2
	winner = nil
	
	a1 = 0
	b1 = 0
	c1 = 0
	a2 = 0
	b2 = 0
	c2 = 0
	a3 = 0
	b3 = 0
	c3 = 0
	
	platform.window:invalidate()
end

on.escapeKey()	-- resets game upon launch

function on.paint(gc)
	gc:setFont("sansserif", "r", 10)
	if titles then	-- draws the splashscreen
		if twoHumans then
			gc:drawString("Two Player Game Mode", 10, 10, "top")
		else
			gc:drawString("Single Player Game Mode", 10, 10, "top")
		end

		gc:setFont("sansserif", "b", 15)
		gc:drawString("Tic-Tac-Toe", 10, 50, "top")
		gc:setFont("sansserif", "r", 10)
		gc:drawString("Game by Karl Noss (karlnoss.com). Version 0.3", 10, 150, "top")
		gc:drawString("ENTER to play. Numpad to enter values.", 10, 175, "top")
		
	else	-- If GAME then

		gc:setFont("sansserif", "r", 6)
		gc:drawString("Game by Karl Noss. Visit KarlNoss.com", 0, 198, "top")

		gc:drawLine(100, 0, 100, 150)	-- draws Tic-Tac-Toe grid
		gc:drawLine(200, 0, 200, 150)
		gc:drawLine(0, 50, 300, 50)
		gc:drawLine(0, 100, 300, 100)

		-- draws rectangles for every spot played
		if a1 == 1 then
			gc:drawRect(10, 10, 80, 30)
		end
		if a1 == 2 then
			gc:fillRect(10, 10, 80, 30)
		end
		if a2 == 1 then
			gc:drawRect(110, 10, 80, 30)
		end
		if a2 == 2 then
			gc:fillRect(110, 10, 80, 30)
		end
		if a3 == 1 then
			gc:drawRect(210, 10, 80, 30)
		end
		if a3 == 2 then
			gc:fillRect(210, 10, 80, 30)
		end
		if b1 == 1 then
			gc:drawRect(10, 60, 80, 30)
		end
		if b1 == 2 then
			gc:fillRect(10, 60, 80, 30)
		end
		if b2 == 1 then
			gc:drawRect(110, 60, 80, 30)
		end
		if b2 == 2 then
			gc:fillRect(110, 60, 80, 30)
		end
		if b3 == 1 then
			gc:drawRect(210, 60, 80, 30)
		end
		if b3 == 2 then
			gc:fillRect(210, 60, 80, 30)
		end
		if c1 == 1 then
			gc:drawRect(10, 110, 80, 30)
		end
		if c1 == 2 then
			gc:fillRect(10, 110, 80, 30)
		end
		if c2 == 1 then
			gc:drawRect(110, 110, 80, 30)
		end
		if c2 == 2 then
			gc:fillRect(110, 110, 80, 30)
		end
		if c3 == 1 then
			gc:drawRect(210, 110, 80, 30)
		end
		if c3 == 2 then
			gc:fillRect(210, 110, 80, 30)
		end
		
		checkMoves()	-- checks for winners
		
		gc:setFont("sansserif", "b", 72)
		if winner ~= nil and winner ~= 0 then
			gc:setFont("sansserif", "b", 72)
			gc:drawString("Winner!", 20, 100, "middle")
		elseif winner == 0 then
			gc:drawString("Game tied.", 20, 100, "middle")
		end
	end
end

function checkMoves()	-- sees which player may have won, checks for ties
	--if a1 == 0 and b1 == 0 and c1 == 0 and a2 == 0 and b2 == 0 and c2 == 0 and a3 == 0 and b3 == 0 and c3 == 0 then
	--	return
	-- First row
	if a1 == a2 and a2 == a3 and a1 ~= 0 then
		winner = a1
	-- 2nd row
	elseif b1 == b2 and b2 == b3 and b1 ~= 0 then
		winner = b1
	--3rd row
	elseif c1 == c2 and c2 == c3 and c1 ~= 0 then
		winner = c1
	--1st column
	elseif a1 == b1 and b1 == c1 and a1 ~= 0 then
		winner = a1
	--2nd column
	elseif a2 == b2 and b2 == c2 and a2 ~= 0 then
		winner = a2
	--3rd column
	elseif a3 == b3 and b3 == c3 and a3 ~= 0 then
		winner = a3
	--Left-right diagonal
	elseif a1 == b2 and b2 == c3 and a1 ~= 0 then
		winner = a1
	-- Right-left diagnol
	elseif a3 == b2 and b2 == c1 and a3 ~= 0 then
		winner = a3
	elseif a1 ~= 0 and b1 ~= 0 and c1 ~= 0 and a2 ~= 0 and b2 ~= 0 and c2 ~= 0 and a3 ~= 0 and b3 ~= 0 and c3 ~= 0 then
		winner = 0
	end
end

function on.charIn(char)	-- interprets user input as placing marks on grid
	if char == "1" then
		c1 = turn
	elseif char == "2" then
		c2 = turn
	elseif char == "3" then
		c3 = turn
	elseif char == "4" then
		b1 = turn
	elseif char == "5" then
		b2 = turn
	elseif char == "6" then
		b3 = turn
	elseif char == "7" then
		a1 = turn
	elseif char == "8" then
		a2 = turn
	elseif char == "9" then
		a3 = turn
	end

	if turn == 2 then	-- switches to the other player's turn
		turn = 1
	else
		turn = 2
	end

	platform.window:invalidate()
end

function on.enterKey()	-- removes splashscreen and repaints
	titles = false
	platform.window:invalidate()
end